#ifndef PixonBot_h
#define PixonBot_h

#include "Arduino.h"


// Esta es la clase PixonBot donde defino el motor,
// los ultrasonidos y los infrarrojos

//////////////////   CLASE   ///////////////////////////////////////

class PixonBot {
  public:

// El constructor de PixonBot requiere (como parámetros)
// el los números de los pines de la placa Arduino para
// asignarselos al controlador L9110S = IB1, IA1, IB2, IA2
// También asigno el pin de Trigger/Echo del ultrasonidos

////////////////// CONSTRUCTOR   //////////////////////////////////

  PixonBot(int IB1, int IA1, int IB2, int IA2, int disparoPin, int ecoPin, int infraD, int infraI);

    // Este método instala en la función setup() de Arduino
    // Los pines como pines de salida (OUTPUT)

//////////////////   MÉTODOS l9110S   //////////////////////////////////
    void begin();

    // Función que solicita el parámetro (velocidad) de cada motor.
    // Esta velocidad estará comprendida entre 0 y 255
    // Que es el PWM que soporta Arduino de salida.
    void avanzar(int velocidadA, int velocidadB);

    void retroceder(int velocidadA, int velocidadB);

    void girarIzquierda(int velocidadA, int velocidadB);

    void girarDerecha(int velocidadA, int velocidadB);

    void stop();


    // Esta función controla el movimiento de los motores
    // para suavizarlo (acerelar / desacelerar)
    void motores(int nuevaVelocidadA, int nuevaVelocidadB);

//////////////////   MÉTODOS ULTRASONIDOS   //////////////////////////////////

    int ping(int disparo, int eco);

    bool obstaculoDetectado(int distanciaMinima);

//////////////////  MÉTODOS LDR     //////////////////////////////////////////
    bool nivelLuz(int pin, int nivel);

//////////////////   MÉTODOS INFRARROJOS   //////////////////////////////////


    int readInfrarrojoDerecho (int infrarrojoDerecho);

    int readInfrarrojoIzquierdo (int infrarrojoIzquierdo);

//////////////////   ATRIBUTOS L9110S   //////////////////////////////////


  private:
    // Variables utilizadas.

//////////////////   ATRIBUTOS L9110S   //////////////////////////////////

    int motorParadoA, motorParadoB, a1, a2, b1, b2;

    bool avanzaA, avanzaB;

//////////////////   ATRIBUTOS ULTRASONIDOS  //////////////////////////////////

    int  disparo, eco, distanciaMinima;

    long distanciaCm;

//////////////////  ATRIBUTOS LDR //////////////////////////////////////////////
    int pin, nivel;

//////////////////   ATRIBUTOS INFRARROJOS  //////////////////////////////////

int infrarrojoDerecho, infrarrojoIzquierdo, valorDerecho, valorIzquierdo;

};

#endif
